"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const ava_1=require("ava"),_1=require("../");function toMs(a){return 1e3*a[0]+1e-6*a[1]}ava_1.test("render simple Hello, World",async(a)=>{try{const b=_1.default(),c=await b`<!doctype html><div>Hello, World!</div>`;a.true("string"==typeof c),a.is(c,`<!DOCTYPE html>
<html>
  <head></head>
  <body>
    <div>Hello, World!</div>
  </body>
</html>`)}catch(b){a.fail(b)}}),ava_1.test("render html with async + sync tasks",async(a)=>{try{const b=_1.default(),c=new Promise((a)=>a("Hello, World!")),d=await b`
    <section>${()=>"<div>Sync Task Func</div>"}</section>
    <section>${"Sync Task"}</section>
    <section>${async()=>"<div>Async Task Func</div>"}</section>
    <section>${c}</section>
    `;a.true("string"==typeof d),a.is(d,`<!DOCTYPE html>
<html>
  <head></head>
  <body>
    <section>
      <div>Sync Task Func</div>
    </section>
    <section>Sync Task</section>
    <section>
      <div>Async Task Func</div>
    </section>
    <section>Hello, World!</section>
  </body>
</html>`)}catch(b){a.fail(b)}}),ava_1.test("cached rendered html with ES6 Map cache store + a unique cached name",async(a)=>{try{const b=new Map,c=_1.default({cacheStore:b,cacheName:"test"}),d=3e3,e=async()=>new Promise((a)=>setTimeout(()=>a("Hello, delay world!"),d)),f=process.hrtime(),g=await c`<div>${e}</div>`,h=process.hrtime(f),i=process.hrtime(),j=await c`<div>${e}</div>`,k=process.hrtime(i);console.log("#",toMs(h),toMs(k)),a.true("string"==typeof g),a.true(toMs(h)>=d),a.is(g,`<!DOCTYPE html>
<html>
  <head></head>
  <body>
    <div>Hello, delay world!</div>
  </body>
</html>`),a.true(10>toMs(k)),a.is(j,`<!DOCTYPE html>
<html>
  <head></head>
  <body>
    <div>Hello, delay world!</div>
  </body>
</html>`)}catch(b){a.fail(b)}}),ava_1.test("cached renderd html with custom TTL",async(a)=>{try{const b=new Map,c=1e4,d=_1.default({cacheStore:b,cacheName:"test",cacheExpiry:c}),e=3e3,f=async()=>new Promise((a)=>setTimeout(()=>a("Hello, delay world!"),e)),g=()=>d`<div>${f}</div>`,h=process.hrtime(),i=await g(),j=process.hrtime(h),k=process.hrtime(),l=await new Promise((a)=>setTimeout(async()=>a((await g())),c+e)),m=process.hrtime(k);console.log("#",toMs(j),toMs(m)),a.true("string"==typeof i),a.true(toMs(j)>=e),a.is(i,`<!DOCTYPE html>
<html>
  <head></head>
  <body>
    <div>Hello, delay world!</div>
  </body>
</html>`),a.true(toMs(m)>=c+e),a.is(l,`<!DOCTYPE html>
<html>
  <head></head>
  <body>
    <div>Hello, delay world!</div>
  </body>
</html>`)}catch(b){a.fail(b)}}),ava_1.test("render minified html",async(a)=>{try{const b=_1.default({minify:!0}),c=await b`
    <div>
      <h1>Hello, World!</h1>
      <ul>
        <li>One</li>
        <li>Two</li>
        <li>Three</li>
      </ul>
    </div>
    `;a.true("string"==typeof c),a.is(c,"<!DOCTYPE html><html><head></head><body><div><h1>Hello, World!</h1><ul><li>One</li><li>Two</li><li>Three</li></ul></div></body></html>")}catch(b){a.fail(b)}}),ava_1.test("render with noParse",async(a)=>{try{const b=_1.default({parseHtml:!1}),c=await b`
      <style>
        div {
          font-size: 2em;
          color: blue;
        }
      </style>
      <div>Hello, World!</div>
    `;a.is(c,`<style>
  div {
    font-size: 2em;
    color: blue;
  }
</style>
<div>Hello, World!</div>`)}catch(b){a.fail(b)}}),ava_1.test("render with noParse but minify html",async(a)=>{try{const b=_1.default({parseHtml:!1,minify:!0}),c=await b`
      <style>
        div {
          font-size: 2em;
          color: blue;
        }
      </style>
      <div>Hello, World!</div>
    `;a.is(c,"<style>div{font-size:2em;color:#00f}</style><div>Hello, World!</div>")}catch(b){a.fail(b)}}),ava_1.test("render without HTML minification",async(a)=>{try{const b=_1.default({minify:!1}),c=await b`
      <style>
        div {
          font-size: 2em;
          color: blue;
        }
      </style>
      <div>Hello, World!</div>
    `;a.is(c,`<!DOCTYPE html>
<html>
  <head>
    <style>
      div {
        font-size: 2em;
        color: blue;
      }
    </style>
  </head>
  <body>
    <div>Hello, World!</div>
  </body>
</html>`)}catch(b){a.fail(b)}});